package org.jboss.qa.brms.performance;

import org.junit.Test;
import org.kie.api.KieBase;
import org.kie.api.conf.EventProcessingOption;
import org.kie.internal.builder.conf.PhreakOption;
import org.kie.internal.utils.KieHelper;

public class Drools6KBaseCreationTest {
    private static int LOOPS = 20;

    private KieBase kbase;

    @Test
    public void testCreateKBaseFromDrl() {
        for (int i = 0; i < LOOPS; i++) {
            executeOneLoop(i);
        }
    }

    private void createKBase(String dslName, String dslrName) {
        KieHelper kieHelper = new KieHelper();
        kieHelper.addFromClassPath("/" + dslName);
        kieHelper.addFromClassPath("/" + dslrName);
        kbase = kieHelper.build();
    }

    private void executeOneLoop(int loopNumber) {
        long start = System.nanoTime();
        createKBase("dsl-kbase-creation.dsl", "dslr-kbase-creation.dslr");
        long took = System.nanoTime() - start;
        System.out.println("Loop #" + loopNumber + "took " + took / 1000 / 1000 + "ms.");
        System.gc();
    }

}
